//
//  StatusViewController.m
//  Uniterm
//
//  Created by John Schember on 12/23/15.
//  Copyright © 2015 Monetra Technologies, LLC All rights reserved.
//

#include <Uniterm/Uniterm.h>

#import "AppDelegate.h"
#import "ResultViewController.h"
#import "StatusViewController.h"
#import "TransRunner.h"

@interface StatusViewController ()

@end

@implementation StatusViewController

TransRunner *_transRunner;
BOOL         _isTranRunning = NO;

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    _transRunner = [TransRunner transRunner];
    [_transRunner setDelegate:self];
    
    _statusLabel.text = @"Uniterm";
    [_cancelButton setEnabled:NO];
    
    [self runTxn];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)runTxn {
    NSDictionary *data;

    _statusLabel.text = @"Uniterm";
    
    @synchronized(self) {
        if (self.requestKVS == nil)
            return;

        data = self.requestKVS;
        self.requestKVS = nil;
        
        if (_isTranRunning)
            return;
        
        _isTranRunning = YES;
    }
    
    [_transRunner runTransRequest:data];
}

- (IBAction)do_cancel:(id)sender {
    [_transRunner cancelRunningTran];
}

- (void)updateStatus:(NSString *)status allowCancel:(BOOL)canCancel {
    dispatch_async(dispatch_get_main_queue(), ^{
        @synchronized(self) {
            if (_isTranRunning) {
                _statusLabel.text = status;
                _cancelButton.enabled = canCancel;
            } else {
                _cancelButton.enabled = NO;
            }
        }
    });
}

- (void)sendResult:(NSDictionary *)result {
    dispatch_async(dispatch_get_main_queue(), ^{        
        @synchronized(self) {
            _isTranRunning = NO;
        }

        _statusLabel.text = @"Uniterm";
        
        ResultViewController *rvc = [self.storyboard instantiateViewControllerWithIdentifier:@"resultScene"];
        rvc.resultKVS = result;
        
        UINavigationController *nav = self.navigationController;
        
        [nav popViewControllerAnimated:NO];
        [nav pushViewController:rvc animated:NO];
    });
}

@end
