//
//  ViewController.m
//  UnitermSim
//
//  Created by John Schember on 3/2/16.
//  Copyright © 2016 Monetra Technologies, LLC All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)sendUnitermRequest:(NSObject *)req {
    BOOL ret;
    
    NSString *requestMessage = [[NSString alloc] initWithData:[NSJSONSerialization dataWithJSONObject:req options:0 error:nil] encoding:NSUTF8StringEncoding];
    
    /* Send the request to Uniterm */
    ret = [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"uniterm://x-callback-url/transaction?x-source=UnitermSim&x-success=unitermsim://result&x-error=unitermsim://error&request=%@", [requestMessage stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]]]]];
    
    if (!ret) {
        UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"Error" message:@"Failed to open UniTerm" preferredStyle:UIAlertControllerStyleAlert];
        
        UIAlertAction *aa = [UIAlertAction actionWithTitle:@"Ok" style:UIAlertActionStyleDefault handler:^(UIAlertAction * action){}];
        
        [alert addAction:aa];
        [self presentViewController:alert animated:YES completion:nil];
    }
}

- (IBAction)do_sale:(id)sender {
    NSMutableDictionary *req = [NSMutableDictionary dictionary];
    
    [req setObject:@"txnrequest" forKey:@"u_action"];
    [req setObject:@"sale" forKey:@"action"];
    [req setObject:@"1" forKey:@"u_id"];

    [req setObject:_amountField.text forKey:@"amount"];
    
    _resultView.text = @"Waiting for result...";
    [self sendUnitermRequest:req];
}

- (void)set_result:(NSDictionary *)result {
    NSMutableString *resultText = [NSMutableString string];
    
    for (NSString *key in [result allKeys]) {
        [resultText appendString:key];
        [resultText appendString:@" \t=\t "];
        [resultText appendString:[result objectForKey:key]];
        [resultText appendString:@"\n"];
    }
    
    if ([resultText length] == 0)
        [resultText appendString:@"None"];
    
    [_resultView setText:resultText];
}

- (void)showErrorWithCode:(NSString *)code message:(NSString *)message
{
    NSString *errorText = [NSString stringWithFormat:@"ERROR\nCode: %@\nMessage: %@", code, message];
    [_resultView setText:errorText];
}

@end
